# gfs_opendir

## Name

gfs_opendir -- open a directory

## Synopsis

    #include <gfarm/gfarm.h>

```char *gfs_opendir``(const char * `gfarm_url`, GFS_Dir * `dirp`);`

## DESCRIPTION

The `gfs_opendir()` function opens a directory stream corresponding to the directory `gfarm_url`, and returns the directory stream to the address pointed by `dirp`. The stream is positioned at the first entry in the directory.

## RETURN VALUES

`NULL`

  The function terminated successfully.

`GFARM_ERR_NO_MEMORY`

  Insufficient memory was available.

`GFARM_ERR_AUTHENTICATION`

  User authentication failed when connecting to gfmd(8).

`GFARM_ERR_PERMISSION_DENIED`

  `gfarm_url` points outside your accessible address space.

`GFARM_ERR_NO_SUCH_OBJECT`

  Directory does not exist.

Others

  An error except the above occurred. The reason is shown by its pointed strings.

## SEE ALSO

gfs_closedir(3), gfs_readdir(3)